#ifndef SERIALPORT_H
#define SERIALPORT_H


#ifdef _WIN32

#define ARDUINO_WAIT_TIME 2000
#define MAX_DATA_LENGTH 255

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#endif

#ifdef __linux__

#include <errno.h>
#include <fcntl.h> 
#include <string.h>
#include <termios.h>
#include <unistd.h>

#endif

class SerialPort
{
private:

    
    #ifdef _WIN32

    HANDLE handler;
    bool connected;
    COMSTAT status;
    DWORD errors;

    #endif
    

    
    
    
    
public:
    
    #ifdef __linux__
        
    bool connected;
    int portFile;

    #endif
    
    SerialPort();
    
    #ifdef __linux__
    
    int setAttributes (int portFile, int speed);
    
    #endif

    void closePort();
    void connectToPort(char *portName);
    int readSerialPort(unsigned char *buffer, unsigned int buf_size);
    bool writeSerialPort(unsigned char *buffer, unsigned int buf_size);
    bool isConnected();
    void flushInput();
};

#endif // SERIALPORT_H
