#include "message.h" 
#include <fcntl.h> 

message::message(){

    
    for(char ii = 0; ii < 64; ii ++){
        
        Message[ii] = 0;
        
        Reply[ii] = 0;
        
        if (ii < 60){
            
            MessData[ii] = 0;
            
        }
        
    }
    
    rType = "";
    
    rSubType = "";
    
    rValue = 0;
    
    SerialNum = 1;
    
       // Header = {{"Frequency", 0}, {"Seconds", 0}, {"numTriggers", 0}, {"Delay", 0}, {"HWPin", 0}, {"ADCPin", 0}, {"HWEnabled", 0}, {"SWEnabled", 0}, {"ConfigEnabled", 0}};
          Header = {{"Frequency", 0}, {"Milliseconds", 0}, {"numTriggers", 0}, {"Delay", 0}, {"HWPin", 0}, {"ADCPin", 0}, {"SWEnabled", 0}, {"ConfigEnabled", 0}};
        
        SubTypeRx = {{255, "Frequency"}, {240, "Milliseconds"}, {219, "numTriggers"}, {194, "Delay"}, {170, "HWPin"}, {153, "ADCPin"}, {102, "HWEnabled"}, {85, "SWEnabled"}, {54, "ConfigEnabled"}, {45, "ADCStatus"}};
        
        SubTypeTx = {{"Frequency", 255}, {"Milliseconds", 240}, {"numTriggers", 219}, {"Delay", 194}, {"HWPin", 170}, {"ADCPin", 153}, {"HWEnabled", 102}, {"SWEnabled", 85}, {"ConfigEnabled", 54}, {"ADCStatus", 45}};
        
        TypeRx = {{240, "Push"}, {170, "Request"}, {85, "Echo"}, {54, "Data"}};
        
        TypeTx = {{"Push", 240}, {"Request", 170}, {"Echo", 85}, {"Data", 54}};
        
        ErrorRx = {{240, "Error"}, {170, "Clean"}};
        
        ErrorTx = {{"Error", 240}, {"Clean", 170}};
    
}
          
          
void message::createMessage(std::string Type, std::string SubType, int Value){
    
    message::Message[0] = TypeTx[Type];
    
    message::Message[1] = SubTypeTx[SubType];
    
    message::Message[2] = (Value >> 24) & 0xFF;
    
    message::Message[3] = (Value >> 16) & 0xFF;
    
    message::Message[4] = (Value >> 8 ) & 0xFF;
    
    message::Message[5] =  Value        & 0xFF;
    
    int checkSum = 0;
    
    for (int ii = 0; ii < 6; ii++){
        
        checkSum += message::Message[ii];
        
    }
    
    message::Message[6] = (checkSum >> 8) & 0xFF;
    
    message::Message[7] =  checkSum       & 0xFF;
    
}
        
    
    
    
/*void  message::createMessage(int Type, int SubType, int Value[64]){
    
    //DON'T NEED ANYTHING HERE AS OF RIGHT NOW.  NOT SENDING ANY DATA TO TEENSY        
    
}*/
    
bool message::waitForMessage(unsigned char ReplyBuffer[64], SerialPort readPort, double  waitTime /*SECONDS I BELIEVE*/){
    
    auto start = std::chrono::system_clock::now();
    auto end = std::chrono::system_clock::now();

    auto elapsed = (end - start);
    
    while ((std::chrono::duration_cast<std::chrono::seconds>(elapsed)).count() < waitTime){
        
        if (readPort.readSerialPort(ReplyBuffer, 64) > 0){ 

            return (true);

        }
        
        std::this_thread::sleep_for(std::chrono::milliseconds(11));

        end = std::chrono::system_clock::now();
        
        elapsed = end - start;
    }
    
    return (false);
    
}


int message::sendMessage(unsigned char ReplyBuffer[64], SerialPort writePort, std::string Type, std::string SubType, int Value){
    
    message::createMessage(Type, SubType, Value);
    
    writePort.flushInput();
    
    bool written = writePort.writeSerialPort(message::Message, 64);
    
    if (Type != "Data"){
        
        bool thisFlag = false;
        
        if (Type != "Echo"){
                    
            thisFlag = message::waitForMessage(ReplyBuffer, writePort, 1);
            
        }
        else {
            
            thisFlag = 1;
            
        }
        
            if (thisFlag){
                                                                        
                            
                    if ((message::Reply[0] == message::TypeTx["Echo"]) && (Type != "Echo")){
                        
                        if (Type == "Push") {
                            
                            return (Value);                        
                                                            
                        
                        }
                        
                        else {
                        
                                message::rType = "";
                                
                                message::rSubType = "";
                                
                                message::rValue = 0;
                                
                                message::parseMessage(message::Reply);
                                
                                return (rValue);
                                
                        }
                        
                    }
                        
                    else {
                        
                        return (0);
                        
                    }
                
            }
            
            else {
                
                return (0);   
                
            }

    }
    
    else {
        
        return (0);   
    
    }
    
}
    
void message::parseMessage(unsigned char messageArray[]){

    if (messageArray[0] == TypeTx["Data"]){

        message::rType = TypeRx[messageArray[0]];
        
        message::SerialNum = (messageArray[1] << 16) + (messageArray[2] << 8) + messageArray[3];
        
        for (int ii = 0; ii < 60; ii++){
        
            message::MessData[ii] = messageArray[ii+4];
            
        }
        
    }
    
    else {
        
        message::rType = TypeRx[messageArray[0]];
        
        message::rSubType = SubTypeRx[messageArray[1]];
        
        message::rValue = (messageArray[2] << 24) + (messageArray[3] << 16) + (messageArray[4] << 8) + messageArray[5];
        
        int checkSum = (messageArray[6] << 8) + messageArray[7];
        
        int sumCheck = 0;
        
        for (int ii = 0; ii < 6; ii++){
            
                sumCheck += messageArray[ii];
            
        }

        if (sumCheck != checkSum){
            
            message::rType = "";
        
            message::rSubType = "";
        
            message::rValue = 0;
            
        }

    }
    
}
